// sNZVF[_[̓
struct PS_INPUT
{
	float4 Diffuse		: COLOR0;	// fBt[YJ[
	float4 Specular		: COLOR1;	// XyLJ[
	float2 TexCoords0	: TEXCOORD0;	// eNX`W
	float4 ShadowMapUV	: TEXCOORD1;	// eNX`[Wnɍsϊ_W
} ;

// sNZVF[_[̏o
struct PS_OUTPUT
{
	float4 Color0		: COLOR0;
} ;


// C++ Őݒ肷萔eNX`̒`
sampler DiffuseMapTexture	: register( s0 );	// fBt[Y}bveNX`
sampler ShadowMapTexture	: register( s1 );	// VhE}bveNX`


// main֐
PS_OUTPUT main( PS_INPUT PSInput )
{
	PS_OUTPUT PSOutput;
	float4 TextureDiffuseColor;
	float4 DefaultOutput;
	float Shadow;
	float2 DepthTexCoord ;

	DepthTexCoord.x = PSInput.ShadowMapUV.x / PSInput.ShadowMapUV.w *  0.5f + 0.5f ;
	DepthTexCoord.y = PSInput.ShadowMapUV.y / PSInput.ShadowMapUV.w * -0.5f + 0.5f ;

	// eNX`J[̓ǂݍ
	TextureDiffuseColor = tex2D( DiffuseMapTexture, PSInput.TexCoords0 );

	// eC[WeNX`[e擾
	Shadow = tex2D( ShadowMapTexture, DepthTexCoord ).r;

	// Kɒ
	Shadow = max( 0.1f, Shadow * Shadow );

	// AƉeȂ߂炩ɂ邽߂ɈÂK
	// o̓J[ = eNX`J[ * fBt[YJ[ + XyLJ[
	DefaultOutput = TextureDiffuseColor * min( ( PSInput.Diffuse.r + PSInput.Diffuse.g + PSInput.Diffuse.b ) * 0.3333f, Shadow ) + PSInput.Specular;
	//DefaultOutput = TextureDiffuseColor * PSInput.Diffuse + PSInput.Specular;

	// o̓At@ = eNX`At@ * fBt[YAt@
	DefaultOutput.a = TextureDiffuseColor.a * PSInput.Diffuse.a;

	// o̓J[Zbg
	PSOutput.Color0 = DefaultOutput;


	// o̓p[^Ԃ
	return PSOutput ;
}


